defmodule ChronoscopeWeb.API.V1.NTS.KeyEstablishmentController do
  use ChronoscopeWeb, :controller

  require Logger

  alias Chronoscope.NTS

  @default_port "4460"

  def get(conn, params) do
    host = to_charlist(params["host"])
    port = String.to_integer(params["port"] || @default_port)

    case NTS.key_establishment(host, port) do
      {:ok, configuration} ->
        ok_response(conn, %{status: :ok, configuration: configuration})

      {:error, error} ->
        ok_response(conn, %{status: :error, reason: to_string(error)})
    end
  end

  defp ok_response(conn, body) do
    conn
    |> Plug.Conn.put_resp_content_type("application/json")
    |> Plug.Conn.send_resp(:ok, Jason.encode!(body))
  end
end
